using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.IO;
//using System.Runtime;
//using System.Runtime.ExceptionServices;
//using System.Security.Permissions;
using UnityEngine;
using UnityEngine.Events;
using TMPro;
namespace stickpart {
  public class EnviromentChanger: MonoBehaviour {
    public void Start() {
      Config = GameObject.FindObjectsOfType<MapConfig>()[0];
	  if(fallback == null)
	  {
		  Debug.Log("Creating new fallback Template");
      fallback = Config.Settings.ShallowClone();
	  }
      Light = gameObject.transform.Find("glow").gameObject;
      this.Light.SetActive(active);
      this.PB = gameObject.GetComponent < PhysicalBehaviour > ();
      Sync();
	  PB.ContextMenuOptions.Buttons.Add(new ContextMenuButton("tfl","Refresh default template", "Refresh default template", new UnityAction[] {
        delegate() {
          fallback = Config.Settings.ShallowClone();
        }
      }));
      PB.ContextMenuOptions.Buttons.Add(new ContextMenuButton("tfl", delegate() {
        return this.Floodlights + ": Floodlights";
      }, "Toggle floodlights", new UnityAction[] {
        delegate() {
          Floodlights = !Floodlights;

        }
      }));
      PB.ContextMenuOptions.Buttons.Add(new ContextMenuButton("tr", delegate() {
        return this.Rain + ": Rain";
      }, "Toggle rain", new UnityAction[] {
        delegate() {
          Rain = !Rain;

        }
      }));
      PB.ContextMenuOptions.Buttons.Add(new ContextMenuButton("ts", delegate() {
        return this.Snow + ": Snow";
      }, "Toggle snow", new UnityAction[] {
        delegate() {
          Snow = !Snow;

        }
      }));
      PB.ContextMenuOptions.Buttons.Add(new ContextMenuButton("tff", delegate() {
        return this.Fog + ": Fog";
      }, "Toggle fog", new UnityAction[] {
        delegate() {
          Fog = !Fog;

        }
      }));
      PB.ContextMenuOptions.Buttons.Add(new ContextMenuButton("setl", delegate() {
        return this.Lightning_chance + ": Lightning Chance";
      }, "Set Lightning Chance", () => {
        DialogBox dialog = (DialogBox) null;
        dialog = DialogBoxManager.TextEntry("What chance?\n<color=green><size=26>Default: 0,Currently:" + this.Lightning_chance + "</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
            (UnityAction)(() => {
              float setrange;
              if (float.TryParse(dialog.EnteredText, out setrange)) {
                this.Lightning_chance = setrange;
              }
            })
          }),
          new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
      }));
      PB.ContextMenuOptions.Buttons.Add(new ContextMenuButton("setg", delegate() {
        return this.Gravity + ": Gravity";
      }, "Set Gravity", () => {
        DialogBox dialog = (DialogBox) null;
        dialog = DialogBoxManager.TextEntry("What gravity (Y Force Coordinate)?\n<color=green><size=26>Default: -9.81,Currently:" + this.Gravity + "</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
            (UnityAction)(() => {
              float setrange;
              if (float.TryParse(dialog.EnteredText, out setrange)) {
                this.Gravity = setrange;
              }
            })
          }),
          new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
      }));
    }
    void Sync() {
      Gravity = Mathf.Clamp(Gravity, -40f, 40f);
      Lightning_chance = Mathf.Clamp(Lightning_chance, 0f, 100f);
      if (active) {
        EnvironmentalSettings cln = fallback.ShallowClone();
        cln.Floodlights = this.Floodlights;
        cln.Rain = this.Rain;
        cln.Snow = this.Snow;
        cln.Fog = this.Fog;
        cln.Gravity = this.Gravity;
        cln.Lightning_chance = this.Lightning_chance;
        Config.ApplySettings(cln);
      } else {
        Config.ApplySettings(fallback);
      }
    }
    void Use(ActivationPropagation propag) {
		if(propag.Channel == 2)
		{
			fallback = Config.Settings.ShallowClone();
		}
		else
		{
      active = !active;
      this.Light.SetActive(active);
      Sync();
		}
    }
    public bool active = false;
    public bool Floodlights = true;
    public bool Rain = false;
    public bool Snow = false;
    public bool Fog = false;
    public float Gravity = -9.81f;
    public float Lightning_chance = 0f;
    [SkipSerialisation]
    public EnvironmentalSettings fallback;
    [SkipSerialisation]
    GameObject Light;
    [SkipSerialisation]
    PhysicalBehaviour PB;
    [SkipSerialisation]
    MapConfig Config;
  }
  public class KeycardBehaviour : MonoBehaviour
  {
	  void ColorSync()
		{
			Color32 lccc = new Color32(lr,lg,lb,255);
			lightcolor = lccc;
			//Debug.Log(lccc.ToString());
		layer1.GetComponent<SpriteRenderer>().color = lccc;
		}
	  void Start()
	  {
		  layer1 = gameObject.transform.Find("glow").gameObject;
		  //layer1 = gameObject;
		  layer1.SetActive(true);
		  lightcolor = new Color32((byte)lr,(byte)lg,(byte)lb,255);
		  ColorSync();
		  PhysicalBehaviour PB = gameObject.GetComponent<PhysicalBehaviour>();
		  PB.ContextMenuOptions.Buttons.Add(new ContextMenuButton("setcolr", "Set Color", "Set Color", () => {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Enter the color\n<color="+"#"+ColorUtility.ToHtmlStringRGBA(lightcolor)+"><size=26>Default: White,Currently:"+this.lightcolor.ToString()+"</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
                  (UnityAction)(() => {
					Color yag;
						if (ColorUtility.TryParseHtmlString(dialog.EnteredText, out yag))
						{
							Color32 yagh = yag;
							lr = yagh.r;lg = yagh.g;lb = yagh.b;ColorSync();}else{Debug.Log("Could not set color...");}
                  })
                }),
                  new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));
		  PB.ContextMenuOptions.Buttons.Add(new ContextMenuButton("setg", "Set ID", "Set ID", () => {
        DialogBox dialog = (DialogBox) null;
        dialog = DialogBoxManager.TextEntry("What ID?\n<color=green><size=26>Currently:" + this.ID + "</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
            (UnityAction)(() => {
                this.ID = dialog.EnteredText;
            })
          }),
          new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
      }));
	  }
	  public byte lr = 255;public byte lg = 255;public byte lb = 255;public byte la = 255;
	  [SkipSerialisation]
	  Color32 lightcolor;
	  [SkipSerialisation]
	  GameObject layer1;
	  public string ID = "1";
  }
  public class KeycardReaderBehaviour : MonoBehaviour
  {
	  void Start()
	  {
		  Light = gameObject.transform.Find("glow").gameObject;
		  audio = gameObject.GetOrAddComponent<AudioSource>();
		  PhysicalBehaviour PB = gameObject.GetComponent<PhysicalBehaviour>();
		  PB.ContextMenuOptions.Buttons.Add(new ContextMenuButton("setg", "Set ID", "Set ID", () => {
        DialogBox dialog = (DialogBox) null;
        dialog = DialogBoxManager.TextEntry("What ID?\n<color=green><size=26>Currently:" + this.ID + "</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
            (UnityAction)(() => {
                this.ID = dialog.EnteredText;
            })
          }),
          new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
      }));
	  }
	  void Output()
	  {
		  foreach(ushort channel in ActivationPropagation.AllChannels) {
        gameObject.SendMessage("Use", new ActivationPropagation(gameObject, channel), SendMessageOptions.DontRequireReceiver);
      }
	  }
	  IEnumerator Core()
	  {
		  audio.PlayOneShot(beep,1f);
		  Output();
		  Light.SetActive(true);
		  yield
        return new WaitForSeconds(1f);
		Light.SetActive(false);
		debounce = false;
        yield
        return null;
	  }
	  void OnCollisionEnter2D(Collision2D data)
	  {
		  GameObject obj = data.gameObject;
		  KeycardBehaviour keycard = obj.GetComponent<KeycardBehaviour>();
		  if(keycard && !debounce)
		  {
			  if(keycard.ID == this.ID)
			  {
				  debounce = true;
				  StartCoroutine(Core());
			  }
		  }
	  }
	  [SkipSerialisation]
	  bool debounce = false;
	  [SkipSerialisation]
	  AudioSource audio;
	  [SkipSerialisation]
	  public AudioClip beep;
	  [SkipSerialisation]
    GameObject Light;
	  public string ID = "1";
  }
  public class KeypadBehaviour : MonoBehaviour
  {
	  void Start()
	  {
		  Light = gameObject.transform.Find("glow").gameObject;
		  audio = gameObject.GetOrAddComponent<AudioSource>();
		  PB = gameObject.GetComponent<PhysicalBehaviour>();
		  PB.ContextMenuOptions.Buttons.Add(new ContextMenuButton("setp", "Set password", "Set password", () => {
        DialogBox dialog = (DialogBox) null;
        dialog = DialogBoxManager.TextEntry("What password?", "Number", new DialogButton("Apply", true, new UnityAction[1] {
            (UnityAction)(() => {
                int setrange;
	            if (Int32.TryParse(dialog.EnteredText, out setrange)) {
	              this.password = setrange;
	            }
            })
          }),
          new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
      }));
	  PB.ContextMenuOptions.Buttons.Add(new ContextMenuButton("sete", "Enter password", "Enter password", () => {
       opendialog();
      }));
	  }
	  void Use(ActivationPropagation propag)
	  {
		  if(!propag.Contains(gameObject) && !debounce)
		  {
			  opendialog();
		  }
	  }
	  void Output()
	  {
		  foreach(ushort channel in ActivationPropagation.AllChannels) {
        gameObject.SendMessage("Use", new ActivationPropagation(gameObject, channel), SendMessageOptions.DontRequireReceiver);
      }
	  }
	  IEnumerator Core()
	  {
		  audio.PlayOneShot(beep,1f);
		  Output();
		  Light.SetActive(true);
		  yield
        return new WaitForSeconds(1f);
		Light.SetActive(false);
		debounce = false;
        yield
        return null;
	  }
	  void checkpassword(int input)
	  {
		  if(input == this.password)
		  {
			 debounce = true;
			 StartCoroutine(Core()); 
		  }
	  }
	  void opendialog()
	  {
		  if(dialogongoing){return;}
		  dialogongoing = true;
		   DialogBox dialog = (DialogBox) null;
        dialog = DialogBoxManager.TextEntry("Enter the password.", "Number", new DialogButton("Apply", true, new UnityAction[1] {
            (UnityAction)(() => {
                int setrange;
	            if (Int32.TryParse(dialog.EnteredText, out setrange)) {
	              checkpassword(setrange);
				  dialogongoing = false;
	            }
            })
          }),
          new DialogButton("Cancel", true, (UnityAction)(() => {dialogongoing = false;dialog.Close();})));
	  }
	  void OnCollisionEnter2D(Collision2D data)
	  {
		  GameObject obj = data.gameObject;
		  MousePartBehaviour plr = obj.GetComponent<MousePartBehaviour>();
		  if(plr && !debounce)
		  {
			  opendialog();
		  }
	  }
	  [SkipSerialisation]
	  PhysicalBehaviour PB;
	  [SkipSerialisation]
	  bool dialogongoing = false;
	  [SkipSerialisation]
	  bool debounce = false;
	  [SkipSerialisation]
	  AudioSource audio;
	  [SkipSerialisation]
	  public AudioClip beep;
	  [SkipSerialisation]
    GameObject Light;
	  public int password = 1234;
  }
  public class DestroyerBehaviour : MonoBehaviour
  {
	  void Start()
	  {
		  Light = gameObject.transform.Find("glow").gameObject;
		  PhysicalBehaviour PB = gameObject.GetComponent<PhysicalBehaviour>();
		 PB.ContextMenuOptions.Buttons.Add(new ContextMenuButton("ada", delegate() {
        return "Advanced: "+advanced;
      }, "Set to advanced and back", () => {
       advanced = !advanced;
      })); 
	  }
	  void Use()
	  {
		active = !active;
		Light.SetActive(active);
	  }
	void yeet(GameObject toyeet)
	{
		if(advanced)
		{
			ModAPI.CreateParticleEffect("Disintegration", toyeet.transform.position);
			Destroy(toyeet);
		}
		else
		{
			PhysicalBehaviour pb = toyeet.GetComponent<PhysicalBehaviour>();
			if(pb)
			{ModAPI.CreateParticleEffect("Disintegration", toyeet.transform.position);pb.Disintegrate();}
		}
	}
	void OnCollisionEnter2D(Collision2D data)
	  {
		  GameObject obj = data.gameObject;
		  if(active)
		  {
			  FreezeBehaviour freeze = obj.GetComponent<FreezeBehaviour>();
			  if(freeze == null)
			  {
			  yeet(obj);
			  }
		  }
	  }
	  [SkipSerialisation]
    GameObject Light;
	  public bool advanced = false;
public bool active = false;	  
  }
  public class ActivationConverter : WaterSensor
  {
	  public override void Setup() {
		  PR = gameObject.GetComponent<PhysicalBehaviour>();
		  PR.ActivationPropagationDelay = -1f;
		 namekeys = new Dictionary < int, string > () {
         {
           0,
           "Single Trigger"
         }, {
           1,
           "Double Trigger"
         }
       };
	   maxmode = 1;
	 }
	 void changepropag(float r)
	 {
		 PR.ActivationPropagationDelay = r;
	 }
	  void UseContinuous() {
		  Activating = true;
		  framebuff = 0;
	  }
     public override void FixedUpdate() {
		 framebuff = Mathf.Clamp(framebuff+1,0,5000);
		 if(framebuff >= 30)
		 {
			 Activating = false;
		 }
		 //NOTE:  above might overflow int limit
		 //Debug.Log(framebuff+": "+Activating);
         bool flag =  Activating;
         if (flag && !variable1) {
           variable1 = true;
           foreach(ushort channel in ActivationPropagation.AllChannels) {
			   changepropag(0f);
             gameObject.SendMessage("Use", new ActivationPropagation(gameObject, channel), SendMessageOptions.DontRequireReceiver);
			 changepropag(-1f);
           }
         }
         if (!flag && variable1) {
           variable1 = Activating;
           if (mode == 1) {
             foreach(ushort channel in ActivationPropagation.AllChannels) {
				 changepropag(0f);
               gameObject.SendMessage("Use", new ActivationPropagation(gameObject, channel), SendMessageOptions.DontRequireReceiver);
			   changepropag(-1f);
             }
           }
         }
     }
	 [SkipSerialisation]
	 PhysicalBehaviour PR;
	 [SkipSerialisation]
	 bool Activating = false;
	 [SkipSerialisation]
	 int framebuff = 0;
  }
  //BROKEN, Please fix.
  public class TriggerSensor: MonoBehaviour {
    void Sync() {
		scale_x = 1f * multiplier;
		scale_y = 1f *multiplier;
		ColliderDrawer.active = showcollider;
      temp_scale = new Vector2(scale_x, scale_y);
      Trigger.size = temp_scale;
	  Debug.Log(Trigger.size.ToString());
    }
    void Start() {
      string[] namekeys = new string[] {
        "Single",
        "Continuous"
      };
	  ColliderDrawer = gameObject.GetOrAddComponent<debugcoll>();
	  ColliderDrawer.active = showcollider;
	  ColliderDrawer.col = Trigger;
      temp_scale = new Vector2(scale_x, scale_y);
      PhysicalBehaviour pb = gameObject.GetComponent < PhysicalBehaviour > () as PhysicalBehaviour;
      pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("changemode", delegate() {
        return "Current Mode: " + namekeys[mode];
      }, "Change detection mode", new UnityAction[] {
        delegate() {
          int proccesing = mode;
          proccesing += 1;
          //there is definently a better way to limit it
          if (proccesing > 1) {
            proccesing = 0;
          }
          mode = proccesing;
        }
      }));
      pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("setsize", "Set Size Multiplier", "Sets size multiplier", () => {
        DialogBox dialog = (DialogBox) null;
        dialog = DialogBoxManager.TextEntry("Enter size\n<color=green><size=26>Default: *2 ,Currently: *" + multiplier + "</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
            (UnityAction)(() => {
              float setrange;
                    if (float.TryParse(dialog.EnteredText, out setrange)) {
						Debug.Log(setrange.ToString());
                      this.multiplier = setrange;
					  Sync();
                    }
            })
          }),
          new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
      }));
    }
    void FixedUpdate() {

      }
      [SkipSerialisation]
    public Vector2 temp_scale;
	public float multiplier = 1f;
    public float scale_y = 1f;
    public float scale_x = 1f;
    public bool showcollider = true;
    [SkipSerialisation]
    debugcoll ColliderDrawer;
    [SkipSerialisation]
    public BoxCollider2D Trigger;
    int mode = 0;
  }
  public class HeightSensor : WaterSensor
  {
	  public override void Setup()
	  {
		  PhysicalBehaviour pb = gameObject.GetComponent<PhysicalBehaviour>();
		  this.glow = gameObject.transform.Find("glow").gameObject;
		  //glow.SetActive(active);
		  text.enabled = active;
		  text.text = height.ToString();
		  pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("mina", "Set Min. Height", "Set Min. Height", () => {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Enter height\n<color=green><size=26>Default: 10,Currently:"+this.minh+"</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
                  (UnityAction)(() => {
                    float setrange;
                    if (float.TryParse(dialog.EnteredText, out setrange)) {
                      this.minh = setrange;
                    }
                  })
                }),
                  new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));
			pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("Maxa", "Set Max. Height", "Set Max. Height", () => {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Enter height\n<color=green><size=26>Default: 10,Currently:"+this.maxh+"</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
                  (UnityAction)(() => {
                    float setrange;
                    if (float.TryParse(dialog.EnteredText, out setrange)) {
                      this.maxh = setrange;
                    }
                  })
                }),
                  new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));
	  }
	  void Use(ActivationPropagation propag)
	  {
		  if(!propag.Contains(gameObject))
		  {
			  active = !active;
			  text.enabled = active;
		  }
	  }
	  public override void PerUpdate()
	  {
		  text.text = Math.Round((decimal)height, 1).ToString();
		  if(framebuff == 10)
		{
			framebuff = 0;
		this.glow.SetActive(false);
		}
		else
		{
			framebuff++;
		}
	  }
	  public override bool CanPass()
	  {
		  //Debug.Log((int)height);
		  if((int)height >= (int)minh && (int)height <= (int)maxh && active)
		  {
			  glow.SetActive(true);
			  return true;
		  }
		  else {return false;}
	  }
	  [SkipSerialisation]
	  public float height
	  {
		  get { return transform.position.y;}
		  set { height = value;}
	  }
	  [SkipSerialisation]
	  private int framebuff = 0;
	  public float minh = 10f;
	  public float maxh = 10f;
	  public bool active = true;
	  [SkipSerialisation]
	  GameObject glow;
	  [SkipSerialisation]
	  public TextMeshPro text;
  }
  public class BloodTransfererEngine : BloodTransferer
  {
	  public override Vector2 Limits
	{
		get
		{
			return new Vector2(0f, 10f);
		}
	}
	public override BloodContainer.PressureDirection Pressure
	{
		get
		{
			return BloodContainer.PressureDirection.Pull;
		}
	}
  }
	public class BloodEngineBehaviour : MonoBehaviour
	{
		public void Start()
		{
			pb = gameObject.GetComponent<PhysicalBehaviour>();
			container = gameObject.GetComponent<BloodTransfererEngine>();
		}
		public float ChargeAmount()
		{
			return container.ScaledLiquidAmount * 10f;
		}
		public void FixedUpdate()
		{
			float x = ChargeAmount();
			//Debug.Log(x);
			pb.Charge = x;
			container.Drain(0.0025f);
		}
		[SkipSerialisation]
		PhysicalBehaviour pb;
		[SkipSerialisation]
		BloodTransfererEngine container;
	}
	public class thrusterpatch : MonoBehaviour
	{
		void Start()
		{
			pb = gameObject.GetComponent<PhysicalBehaviour>();
			thruster = gameObject.GetComponent<ThrusterbedBehaviour>();
			thruster.highAudio.mute = val;
		  thruster.lowAudio.mute = val;
			pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("moot", delegate() {
        return this.val + ": Mute";
      }, "Toggle Mute", new UnityAction[] {
        delegate() {
          val = !val;
		  thruster.highAudio.mute = val;
		  thruster.lowAudio.mute = val;
        }
      }));
		}
		public bool val = false;
		[SkipSerialisation]
		PhysicalBehaviour pb;
		[SkipSerialisation]
		ThrusterbedBehaviour thruster;
	}
	public class SpriteChangerBehaviour : MonoBehaviour
	{
		public void Init()
		{
			renderer = gameObject.GetComponent<SpriteRenderer>();
			var glmng = transform.Find("glow");
			if(glmng != null)
			{
			light = glmng.gameObject.GetComponent<SpriteRenderer>();
			}
			ChangeSprite(ind,FixColl);
			ContextMenuInit();
		}
		private void fixind()
		{
			Debug.Log(ind);
			if(ind>=sprites.Length)
			{
				Debug.Log("above limit,reset engaging.");
				ind = 0;
			}
			else if(ind<0)
			{
				Debug.Log("below limit,reset engaging.");
				ind = sprites.Length;
			}
			Debug.Log(ind+"min : max "+sprites.Length);
			ChangeSprite(ind,FixColl);
		}
		private void ContextMenuInit()
		{
			PhysicalBehaviour pb = gameObject.GetComponent<PhysicalBehaviour>();
			pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("prevtext", "Previous texture", "Switches to the previous texture", new UnityAction[]
		{
			delegate()
			{
				this.ind--;
				this.fixind();
			}
		})
		{
			LabelWhenMultipleAreSelected = "Previous texture"
		});
		pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("nexttext", "Next texture", "Switches to the next texture", new UnityAction[]
		{
			delegate()
			{
				this.ind++;
				this.fixind();
			}
		})
		{
			LabelWhenMultipleAreSelected = "Previous texture"
		});
		}
		public void ChangeSprite(int index,bool unfuckCollider = true)
		{
			renderer.sprite = sprites[index];
			if(light != null){light.sprite = glowsprites[index];}
			if(unfuckCollider){gameObject.FixColliders();}
			gameObject.GetComponent<PhysicalBehaviour>().RefreshOutline();
		}
		[SkipSerialisation]
		private SpriteRenderer renderer;
		[SkipSerialisation]
		private SpriteRenderer light = null;
		public bool FixColl = true;
		[SkipSerialisation]
		public Sprite[] sprites = null;
		[SkipSerialisation]
		public Sprite[] glowsprites = null;
		public int ind = 0;
	}
	public class TouchpadBehaviour : MonoBehaviour
	{
		private void Start()
		{
			ContextMenuInit();
		}
		private void ContextMenuInit()
		{
			PhysicalBehaviour pb = gameObject.GetComponent<PhysicalBehaviour>();
			pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("halive", delegate() {
				return "Has to be alive:" + HasToBeAlive;
			}, "Toggle if hit object has to be alive.", new UnityAction[] {
			delegate() {
				HasToBeAlive = !HasToBeAlive;
			}
			}));
			pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("hfire", delegate() {
				return "Has to be burning:" + HasToBeOnFire;
			}, "Toggle if hit object has to be on fire.", new UnityAction[] {
			delegate() {
				HasToBeOnFire = !HasToBeOnFire;
			}
			}));
			/*pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("hmetal", delegate() {
				return "Has to be metallic:" + HasToBeMetal;
			}, "Toggle if hit object has to be metal.", new UnityAction[] {
			delegate() {
				HasToBeMetal = !HasToBeMetal;
			}
			}));*/
			pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("hdest", delegate() {
				return "Destroy self on impact:" + DestroyOnImpact;
			}, "Pops like a fuse upon a successful activation.", new UnityAction[] {
			delegate() {
				DestroyOnImpact = !DestroyOnImpact;
			}
			}));
			pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("setth", "Set Impact Force Threshold", "Sets threshold.", () => {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Enter the threshold\n<color=green><size=26>Default: 10,Currently:"+ImpactForceThreshold+"</size></color>", "Velocity", new DialogButton("Apply", true, new UnityAction[1] {
                  (UnityAction)(() => {
                    float setrange2;
                    if (float.TryParse(dialog.EnteredText, out setrange2)) {
                        if(setrange2 > -0.0000000000001)
                        {
                            ImpactForceThreshold = setrange2;
                            //CurrentVelocity = setrange2;
                        }
                        else
                        {
                            ModAPI.Notify("<color=red>Error: velocity threshold must be above 0.</color>");
                        }
                    }
                  })
                }),
                  new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));
		}
		private bool FilterIt(Collision2D coll)
		{
			GameObject detected = coll.gameObject;
			PhysicalBehaviour pb = detected.GetComponent<PhysicalBehaviour>();
			if(coll.GetContact(0).normalImpulse < this.ImpactForceThreshold)
			return false;
			if (this.HasToBeAlive)
			{
				AliveBehaviour aliveBehaviour;
				if (!AliveBehaviour.AliveByTransform.TryGetValue(detected.transform.root, out aliveBehaviour))
				{
					return false;
				}
				if (!aliveBehaviour.IsAlive())
				{
					return false;
				}
			}
			if (this.HasToBeOnFire && !pb.OnFire)
			return false;
			return true;
		}
		private void OnCollisionEnter2D(Collision2D coll)
		{
			if(FilterIt(coll))
			{
			Debug.Log("pass");	
			foreach(ushort channel in ActivationPropagation.AllChannels) {
             gameObject.SendMessage("Use", new ActivationPropagation(gameObject, channel), SendMessageOptions.DontRequireReceiver);
           }
				if(DestroyOnImpact)
				{
					ModAPI.CreateParticleEffect("FuseBlown", transform.position).GetComponent<AudioSource>().Stop();
					Destroy(gameObject,0.15f);
				}
			}
		}
		public bool HasToBeAlive = false;
		public bool HasToBeOnFire = false;
		//public bool HasToBeMetal = false;
		public bool DestroyOnImpact = false;
		public float ImpactForceThreshold = 10f;
	}
	public class AutofreezeBehaviour : MonoBehaviour
	{
		//actually this would be just a generic handler at this point
		private void ScaledNotify(string txt,int size = -1)
		{
			string stxt;
			string stxt2;
			if(size==-1){stxt = "";stxt2 = "";}
			else {stxt = "<size="+size+">";stxt2 = "</size>";}
			ModAPI.Notify(stxt+txt+stxt2);
		}
		void Update()
		{
			int generalsize = 48;
				Mod.Autofreeze_Enabled = InputSystem.Held("autofreeze-PNC_jimmyl");
				Mod.Stretchy_Cables = InputSystem.Held("cablestretch-PNC_jimmyl");
		}
	}
	public class LeverBehaviour : MonoBehaviour
	{
		void Start()
		{
			HandleJoint = GetComponent<HingeJoint2D>();
			redlight = transform.Find("glow2").gameObject;
			greenlight = transform.Find("glow1").gameObject;
		}
		private void FixedUpdate()
		{
			float leverstate = 1f - Mathf.Clamp01((this.HandleJoint.jointAngle - this.HandleJoint.limits.min) / (Mathf.Abs(this.HandleJoint.limits.min) + this.HandleJoint.limits.max));
			if(!var1 && leverstate == 0f)
			{
				var1 = true;
				Debug.Log("state 1");
				redlight.SetActive(true);
				gameObject.SendMessage("Use", new ActivationPropagation(gameObject, ActivationPropagation.AllChannels[0]), SendMessageOptions.DontRequireReceiver);
				gameObject.SendMessage("Use", new ActivationPropagation(gameObject, ActivationPropagation.AllChannels[1]), SendMessageOptions.DontRequireReceiver);
			}
			else if (var1 && leverstate >= 0.1f){var1 = false;redlight.SetActive(false);}
			if(!var2 && leverstate == 1f)
			{
				var2 = true;
				Debug.Log("state 2");
				greenlight.SetActive(true);
				gameObject.SendMessage("Use", new ActivationPropagation(gameObject, ActivationPropagation.AllChannels[0]), SendMessageOptions.DontRequireReceiver);
				gameObject.SendMessage("Use", new ActivationPropagation(gameObject, ActivationPropagation.AllChannels[2]), SendMessageOptions.DontRequireReceiver);
			}
			else if (var2 && leverstate <= 0.9f){var2 = false;greenlight.SetActive(false);}
		//Debug.Log(leverstate);
		//this.PhysicalBehaviour.EnergyWireResistance = this.ResistorPower;
		}
		private bool var2 = false;
		private bool var1 = false;
		public HingeJoint2D HandleJoint;
		[SkipSerialisation]
		public GameObject redlight;
		[SkipSerialisation]
		public GameObject greenlight;
	}
		public class ParticleMaker: MonoBehaviour {
  private SettingsMenu SettingsInstance = null;
  void CoordinateProcessor(string[] arr) {
    float x = 1f;
    float y = 1f;
    if (float.TryParse(arr[0], out x)) {
      scale_x = x;
    }
    if (float.TryParse(arr[1], out y)) {
      scale_y = y;
    }
	Debug.Log(scale_x);
	Debug.Log(scale_y);
  }
  private void MakeMenu() {
    if (SettingsInstance == null) {
      SettingsInstance = new SettingsMenu();
    }
    SettingsInstance.Open(new DialogButton[] {
		new DialogButton("All Particles", true, new UnityAction[1] {
            (UnityAction)(() => {
				Utils.OpenURL("https://github.com/mestiez/ppg-snippets/blob/master/all%20particle%20effects.txt");
            })
          }),
		new DialogButton("Particle" + "\n<color=green><size=26>" + particlename + "</size></color>", true, new UnityAction[1] {
            (UnityAction)(() => {
              string text = "Enter the particle name";
              string PlaceholderText = "Spark";
              DialogBox dialog = (DialogBox) null;
              dialog = DialogBoxManager.TextEntry(text, PlaceholderText, new DialogButton("Apply", true, new UnityAction[1] {
                (UnityAction)(() => {
                    particlename = dialog.EnteredText;
                    MakeMenu();
                })
              }), new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
              dialog.InputField.text = particlename;
            })
          }),
        new DialogButton("Particle every X frames" + "\n<color=green><size=26>" + framebuffmax + "</size></color>", true, new UnityAction[1] {
            (UnityAction)(() => {
              string text = "Enter frames (0-50,probably)";
              string Default = "25";
              string PlaceholderText = "Frame";
              DialogBox dialog = (DialogBox) null;
              dialog = DialogBoxManager.TextEntry(text + "\n<color=green><size=26>Default: " + Default + "</size></color>", PlaceholderText, new DialogButton("Apply", true, new UnityAction[1] {
                (UnityAction)(() => {
                  int setrange;
                  if (int.TryParse(dialog.EnteredText, out setrange)) {
                    framebuffmax = setrange;
                    MakeMenu();
                  }
                })
              }), new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
              dialog.InputField.text = framebuffmax.ToString();
            })
          }),
          new DialogButton("Particle Scale" + "\n<color=green><size=26>" + scale_x+","+scale_y + "</size></color>", true, new UnityAction[1] {
            (UnityAction)(() => {
              //floattowards = !floattowards;
              string text = "Enter names seperated by a comma";
              string PlaceholderText = "Species";
              DialogBox dialog = (DialogBox) null;
              dialog = DialogBoxManager.TextEntry(text, PlaceholderText, new DialogButton("Apply", true, new UnityAction[1] {
                (UnityAction)(() => {
                  CoordinateProcessor(dialog.EnteredText.Split(new char[] {
                    ','
                  }, StringSplitOptions.RemoveEmptyEntries));
                  MakeMenu();
                })
              }), new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
              dialog.InputField.text = scale_x+","+scale_y;
            })
          })
    },4);
}
void CreateEffect() {
  GameObject effect = ModAPI.CreateParticleEffect(particlename, transform.position);
  effect.transform.localScale = new Vector3(scale_x, scale_y);
  effect.transform.rotation = transform.rotation;
  if (soundless) {
    AudioSource audio = effect.GetComponent < AudioSource > ();
    if (audio) {
      audio.Stop();
    }
  }
}
void Start() {
  gameObject.GetComponent < PhysicalBehaviour > ().ContextMenuOptions.Buttons.Add(new ContextMenuButton("settingsbutton", "Settings", "Please dont use with multiple parts...", () => {
    MakeMenu();
  }));
}
void Use(ActivationPropagation activation) {
  if (activation.Channel == 2) {
    loop = true;
  } else if (activation.Channel == 1) {
    loop = false;
  } else if (activation.Channel == 0) {
    CreateEffect();
  }
}
void FixedUpdate() {
  if (loop) {
    framebuff++;
    if (framebuff >= framebuffmax) {
      CreateEffect();
      framebuff = 0;
    }
  }
}
public bool soundless = false;
public string particlename = "Spark";
public int framebuffmax = 25;
private int framebuff = 0;
public bool loop = false;
public float scale_x = 1f;
public float scale_y = 1f;
}

public class ChanceGate: MonoBehaviour {
  public float chance = 1f;
  void Start() {
	  RedLight = transform.Find("glow2").gameObject;
			GreenLight = transform.Find("glow1").gameObject;
    PhysBeh = gameObject.GetComponent < PhysicalBehaviour > ();
    PhysBeh.ActivationPropagationDelay = -1f;
    PhysBeh.ContextMenuOptions.Buttons.Add(new ContextMenuButton("satc", "Set Chance", "Set the chance an activation passes", () => {
      DialogBox dialog = (DialogBox) null;
      dialog = DialogBoxManager.TextEntry("Enter the chance\n<color=green><size=26>Default: 100%,Currently:" + this.chance*100 + "%</size></color>", "0-100%", new DialogButton("Apply", true, new UnityAction[1] {
          (UnityAction)(() => {
            float setrange;
            if (float.TryParse(dialog.EnteredText, out setrange)) {
              this.chance = setrange / 100;
            }
          })
        }),
        new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
    }));

  }
  void changepropag(float r)
	 {
		 PhysBeh.ActivationPropagationDelay = r;
	 }
	void Use(ActivationPropagation propag)
	{
		//Debug.Log("Use");
		  if(!propag.Contains(gameObject))
		  {
			  //Debug.Log("UsePass");
		if(!(UnityEngine.Random.value < chance))
			{RedLight.SetActive(true);GreenLight.SetActive(false);return;}
			RedLight.SetActive(false);GreenLight.SetActive(true);
			changepropag(0f);
			gameObject.SendMessage("Use", new ActivationPropagation(gameObject, propag.Channel), SendMessageOptions.DontRequireReceiver);
			changepropag(-1f);
		  }
	}
	[SkipSerialisation]
	public GameObject RedLight;
	[SkipSerialisation]
	public GameObject GreenLight;
    [SkipSerialisation]
  public PhysicalBehaviour PhysBeh;
}
public class StretchyCableFix: MonoBehaviour {
	void OnAfterDeserialise()
	{
		StartCoroutine(checkwithdelay());
		foreach(DistanceJointWireBehaviour ggzooi in GetComponents < DistanceJointWireBehaviour > ()) {
			ggzooi.typedJoint.enabled = false;
		}
	}
  void Checker() {
    Debug.Log("deserialization");
    foreach(DistanceJointWireBehaviour ggzooi in GetComponents < DistanceJointWireBehaviour > ()) {
      Debug.Log("joint detecto");
      Debug.Log(IDs + ":" + ggzooi.currentDistance);
      if (ggzooi.currentDistance == IDs) {
        ggzooi.typedJoint.enabled = false;
      }
	  else
	  {
		  ggzooi.typedJoint.enabled = true;
	  }
    }
  }
  IEnumerator checkwithdelay() {
    while (shouldcheck) {
        yield
        return new WaitForSeconds(0.1f);
        shouldcheck = false;
		Checker();
      yield
      return null;
    }
  }
  private bool shouldcheck = true;
  public float IDs;
}
public class pneis : MonoBehaviour
{
	float scaler()
	{
		return Mathf.Clamp(1f*(pb.Charge/divider),1f,100f);
	}
	void Update()
	{
		transform.localScale = new Vector3(scaler(),scaler(),scaler());
	}
	void Start()
	{
		pb = GetComponent<PhysicalBehaviour>();
	}
	private float divider = 35f;
	[SkipSerialisation]
	PhysicalBehaviour pb;
}
public class inversegate : MonoBehaviour
{
		public void Start()
		{
			PhysBeh = gameObject.GetComponent<PhysicalBehaviour>();
			light = gameObject.transform.Find("glow").gameObject;
		}
		public void Update()
		{
			if(PhysBeh.Charge>1f){light.SetActive(false);}else{light.SetActive(true);}
			this.PhysBeh.ActivationPropagationDelay = ((PhysBeh.Charge>1f) ? -1f : 0f);
		}
		[SkipSerialisation]
		public bool Active = true;
		[SkipSerialisation]
		public PhysicalBehaviour PhysBeh;
		[SkipSerialisation]
	    public GameObject light;
}
public class MultiservoBehaviour : MonoBehaviour
{
	// Token: 0x060005B3 RID: 1459 RVA: 0x0001C3C0 File Offset: 0x0001A5C0
	private void Start()
	{
		//Debug.Log("Custom running");
		//this.SetDelta(this.GreenDelta,0);this.SetDelta(this.RedDelta,1);this.SetDelta(this.BlueDelta,2);
		this.PhysicalBehaviour = gameObject.GetComponent<PhysicalBehaviour>();
		this.AudioSource = gameObject.GetOrAddComponent<AudioSource>();
		this.Hinge = gameObject.GetOrAddComponent<HingeJoint2D>();
		this.GreenIndicatorArm = transform.Find("ServoArm");
		this.RedIndicatorArm = Instantiate(GreenIndicatorArm,transform);
		this.BlueIndicatorArm = Instantiate(GreenIndicatorArm,transform);
		this.BlueIndicatorArm.GetComponent<SpriteRenderer>().color = new Color32(0,0,255,255);
		this.RedIndicatorArm.GetComponent<SpriteRenderer>().color = new Color32(255,0,0,255);
		this.GreenIndicatorArm.GetComponent<SpriteRenderer>().color = new Color32(0,255,0,255);
		this.SetDelta(this.GreenDelta,0);this.SetDelta(this.RedDelta,1);this.SetDelta(this.BlueDelta,2);
		this.PhysicalBehaviour.ContextMenuOptions.Buttons.AddRange(new ContextMenuButton[]
		{new ContextMenuButton("servoSetDeltaG", "Set target green angle", "Set the target green angle of the servo", new UnityAction[]
			{delegate(){
					Utils.OpenFloatInputDialog<MultiservoBehaviour>(this.GreenDelta, this, delegate(MultiservoBehaviour w, float v){
						w.SetDelta(v,0);}, "Set green servo delta", "Angle");}}){
				LabelWhenMultipleAreSelected = "Set servo green target angle"}});
				this.PhysicalBehaviour.ContextMenuOptions.Buttons.AddRange(new ContextMenuButton[]
		{new ContextMenuButton("servoSetDeltaR", "Set target red angle", "Set the target red angle of the servo", new UnityAction[]
			{delegate(){
					Utils.OpenFloatInputDialog<MultiservoBehaviour>(this.RedDelta, this, delegate(MultiservoBehaviour w, float v){
						w.SetDelta(v,1);}, "Set red servo delta", "Angle");}}){
				LabelWhenMultipleAreSelected = "Set servo red target angle"}});
				this.PhysicalBehaviour.ContextMenuOptions.Buttons.AddRange(new ContextMenuButton[]
		{new ContextMenuButton("servoSetDeltaB", "Set target blue angle", "Set the target blue angle of the servo", new UnityAction[]
			{delegate(){
					Utils.OpenFloatInputDialog<MultiservoBehaviour>(this.BlueDelta, this, delegate(MultiservoBehaviour w, float v){
						w.SetDelta(v,2);}, "Set blue servo delta", "Angle");}}){
				LabelWhenMultipleAreSelected = "Set servo blue target angle"}});
	}

	// Token: 0x060005B4 RID: 1460 RVA: 0x0001C433 File Offset: 0x0001A633
	private void Use(ActivationPropagation pr)
	{
		this.Activated = !this.Activated;
		this.CurrentChannel = pr.Channel;
	}

	// Token: 0x060005B5 RID: 1461 RVA: 0x0001C444 File Offset: 0x0001A644
	public void FixedUpdate()
	{
		JointMotor2D motor = this.Hinge.motor;
		motor.motorSpeed = (2f + this.PhysicalBehaviour.Charge) * Mathf.DeltaAngle(this.Hinge.jointAngle, this.Activated ? this.GetScaledDelta(CurrentChannel) : 0f);
		this.Hinge.motor = motor;
		float num = Mathf.Abs(this.Hinge.jointSpeed) * 0.1f;
		if (num > 0.5f)
		{
			if (!this.AudioSource.isPlaying)
			{
				this.AudioSource.Play();
			}
			this.AudioSource.volume = Mathf.Clamp01(num * num);
			return;
		}
		if (this.AudioSource.isPlaying)
		{
			this.AudioSource.Stop();
		}
	}

	// Token: 0x060005B6 RID: 1462 RVA: 0x0001C50A File Offset: 0x0001A70A
	private float GetScaledDelta(ushort channel)
	{
		float g=0f;
		switch(channel)
		{
			case 0: // green
			g = this.GreenDelta;
			break;
			case 1: // red
			g = this.RedDelta;
			break;
			case 2: // blue
			g = this.BlueDelta;
			break;
			default:
			g = 0f;
			break;
		}
		return g * (float)((base.transform.localScale.x > 0f) ? 1 : -1);
	}

	// Token: 0x060005B7 RID: 1463 RVA: 0x0001C52F File Offset: 0x0001A72F
	private void OnDisable()
	{
		this.Hinge.useMotor = false;
		this.AudioSource.Stop();
	}

	// Token: 0x060005B8 RID: 1464 RVA: 0x0001C548 File Offset: 0x0001A748
	private void OnEnable()
	{
		this.Hinge.useMotor = true;
	}

	// Token: 0x060005B9 RID: 1465 RVA: 0x0001C556 File Offset: 0x0001A756
	public void SetDelta(float v,ushort channel)
	{
		switch(channel)
		{
			case 0: // green
			this.GreenDelta = v;
			this.GreenIndicatorArm.localEulerAngles = new Vector3(0f, 0f, this.GreenDelta);
			break;
			case 1: // red
			this.RedDelta = v;
			this.RedIndicatorArm.localEulerAngles = new Vector3(0f, 0f, this.RedDelta);
			break;
			case 2: // blue
			this.BlueDelta = v;
			this.BlueIndicatorArm.localEulerAngles = new Vector3(0f, 0f, this.BlueDelta);
			break;
			default:
			break;
		}
	}

	// Token: 0x040005E0 RID: 1504
	public bool Activated = false;
	public ushort CurrentChannel = 0;
	// Token: 0x040005E1 RID: 1505
	public float GreenDelta = 90f;
	public float RedDelta = 45f;
	public float BlueDelta = 70f;
	// Token: 0x040005E2 RID: 1506
	[SkipSerialisation]
	public Transform GreenIndicatorArm;
	[SkipSerialisation]
	public Transform RedIndicatorArm;
	[SkipSerialisation]
	public Transform BlueIndicatorArm;

	// Token: 0x040005E3 RID: 1507
	[SkipSerialisation]
	public AudioSource AudioSource;

	// Token: 0x040005E4 RID: 1508
	[SkipSerialisation]
	public HingeJoint2D Hinge;

	// Token: 0x040005E5 RID: 1509
	[SkipSerialisation]
	public PhysicalBehaviour PhysicalBehaviour;
}
public class PowerCellBehaviour : MonoBehaviour
{
	void Start()
	{
		chargeindicator = transform.Find("glow");
		chargeindicator.gameObject.SetActive(true);
		phys = GetComponent<PhysicalBehaviour>();
		phys.ForceNoChargeParticles = true;
		phys.ConductOverride = false;
		//StoredCharge = UnityEngine.Random.Range(0f,1000f);
		if(PowerOutput>MaxPowerOutput){PowerOutput = MaxPowerOutput / 2f;}
				this.phys.ContextMenuOptions.Buttons.AddRange(new ContextMenuButton[]
		{new ContextMenuButton("cellSetTargetCharge", "Set cell power output", "Set how much charge can the power cell, discharge", new UnityAction[]
			{delegate(){
					Utils.OpenFloatInputDialog<PowerCellBehaviour>(this.PowerOutput, this, delegate(PowerCellBehaviour w, float v){
						w.PowerOutput = Mathf.Clamp(v,0f,MaxPowerOutput);}, "Power output, Max:"+MaxPowerOutput, "Power");}}){
				LabelWhenMultipleAreSelected = "Set power output of power cells"}});
	}
	void Use(){active = !active;if(!active){phys.Charge = 0f;}}
	void FixedUpdate()
	{
		chargeindicator.localScale = new Vector3(1,Mathf.Clamp01(StoredCharge/MaxStoredCharge));
		//chargeindicator.localPosition = new Vector3(0,-Mathf.Clamp01(StoredCharge/MaxStoredCharge));
		if(active)
		{
			StoredCharge = Mathf.Clamp(StoredCharge-(PowerOutput/100f),0f,MaxStoredCharge);
			phys.Charge = Mathf.Clamp(PowerOutput,0f,StoredCharge);
		}
		else if (!active && phys.Charge > 0.1f)
		{
			StoredCharge = Mathf.Clamp(StoredCharge+(ChargeRate/50f),0f,MaxStoredCharge);
			phys.Charge = Mathf.Clamp(phys.Charge-(ChargeRate/40f),0f,StoredCharge);
		}
	}
	[SkipSerialisation]
	public PhysicalBehaviour phys;
	public float PowerOutput = 50f;
	public float MaxPowerOutput = 100f;
	public float ChargeRate = 50f;
	public bool active = false;
	public float StoredCharge = 0f;
	public float MaxStoredCharge = 1000f;
	public Transform chargeindicator;
}
public class CreativeCell : MonoBehaviour
{
	void Start()
	{
		PhysicalBehaviour phys = GetComponent<PhysicalBehaviour>();
		PowerCellBehaviour cell = GetComponent<PowerCellBehaviour>();
		phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("setmp", "Set Max Power Output", "Set Max Power Output", () => {
      DialogBox dialog = (DialogBox) null;
      dialog = DialogBoxManager.TextEntry("Max Cell Power Output", "Charge", new DialogButton("Apply", true, new UnityAction[1] {
          (UnityAction)(() => {
            float setrange;
            if (float.TryParse(dialog.EnteredText, out setrange)) {
              cell.MaxPowerOutput = setrange;
            }
          })
        }),
        new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));dialog.InputField.text = cell.MaxPowerOutput.ToString();
    }));
	phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("setms", "Set Max Power Storage", "Set Max Power Storage", () => {
      DialogBox dialog = (DialogBox) null;
      dialog = DialogBoxManager.TextEntry("Max Cell Power Storage", "Charge", new DialogButton("Apply", true, new UnityAction[1] {
          (UnityAction)(() => {
            float setrange;
            if (float.TryParse(dialog.EnteredText, out setrange)) {
              cell.MaxStoredCharge = setrange;
            }
          })
        }),
        new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));dialog.InputField.text = cell.MaxStoredCharge.ToString();
    }));
	phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("setcr", "Set Charge Rate", "Set Charge Rate", () => {
      DialogBox dialog = (DialogBox) null;
      dialog = DialogBoxManager.TextEntry("Charge rate", "Charge", new DialogButton("Apply", true, new UnityAction[1] {
          (UnityAction)(() => {
            float setrange;
            if (float.TryParse(dialog.EnteredText, out setrange)) {
              cell.ChargeRate = setrange;
            }
          })
        }),
        new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));dialog.InputField.text = cell.ChargeRate.ToString();
    }));
	}
}
  }