using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.IO;
//using System.Runtime.ExceptionServices;
//using System.Security.Permissions;
using UnityEngine;
using UnityEngine.Events;
namespace stickpart {
  public static class DetectionUtilities {
    public static Transform[] GetTargets<T>(Func<Component,bool> checker) where T : Component {
      List < Transform > Suitables = new List < Transform > ();
      T[] checkobjects = GameObject.FindObjectsOfType(typeof (T)) as T[];
      for (int i = 0; i < checkobjects.Length; i++) {
        GameObject foundobject = checkobjects[i].gameObject;
        if (checker(checkobjects[i])) {
          Suitables.Add(foundobject.transform);
        }
      }
      return Suitables.ToArray();
    }
    public static Transform FindClosestTarget(Vector3 curpos,Transform[] SuitableObjects,float detectionrange = 1000f) {
      if (SuitableObjects == null || SuitableObjects.Length == 0) {
        return null;
      }
      Transform[] enemies = SuitableObjects;
      Transform bestTarget = null;
      float closestDistanceSqr = detectionrange;
      Vector3 currentPosition = curpos;
      foreach(Transform potentialTarget in enemies) {
        Vector3 directionToTarget = potentialTarget.position - currentPosition;
        float dSqrToTarget = directionToTarget.sqrMagnitude;
        if (dSqrToTarget < closestDistanceSqr) {
          closestDistanceSqr = dSqrToTarget;
          bestTarget = potentialTarget;
        }
      }

      return bestTarget;
    }
    public static void RotateTowards(Rigidbody2D RB, Vector2 target, float offsetx = 0f) {
      var offset = offsetx;
      Vector2 direction = target - (Vector2) RB.transform.position;
      direction.Normalize();
      float angle = Mathf.Atan2(direction.y, direction.x) * Mathf.Rad2Deg;
      if (RB.transform.localScale.x < 0) {
        offset = offsetx + 180f;
      }
      for (int i = 0; i < 200; i++) {
        RB.MoveRotation(Quaternion.Euler(Vector3.forward * (angle + offset)));
      }
    }
	public static void MoveTowards(Rigidbody2D RB,Vector2 Target,float step)
	{
		RB.MovePosition(Vector2.MoveTowards(RB.transform.position, Target, step));
	}
  }
}