using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Runtime.ExceptionServices;
using System.Security.Permissions;
using UnityEngine;
using UnityEngine.Events;
using TMPro;
namespace stickpart {
  public class LogicNode: MonoBehaviour {
	private void Start()
	{ light = gameObject.transform.Find("glow").gameObject;Logic = gameObject.transform.parent.Find("defib body").gameObject.GetComponent<LogicGateBase>();}
    private void UseContinuous(ActivationPropagation activation) {
	  //Debug.Log(transform.localPosition.ToString());
      Logic.NodeActivation(activation, slot);
	  framebuff = 0;
	  this.light.SetActive(true);
    }
	private void Use(ActivationPropagation activation) {
	  //Debug.Log(transform.localPosition.ToString());
      Logic.NodeActivation(activation, slot,false);
	  this.light.SetActive(true);
    }
	private void FixedUpdate()
	{
		if(framebuff == 10)
		{
			framebuff = 0;
		this.light.SetActive(false);
		}
		else
		{
			framebuff++;
		}
	}
	
    public int slot = 1;
	[SkipSerialisation]
	private int framebuff = 0;
	[SkipSerialisation]
	GameObject light;
	[SkipSerialisation]
    public LogicGateBase Logic;
  }
  public class LogicGateBase: MonoBehaviour {
    public virtual void Start() {
		light = gameObject.transform.Find("glow").gameObject;
		gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("settingsbutton","Other settings", "Please dont use with multiple parts...", () => {
         LoadMenu();
		}
		 )
		 );
		this.Setup();
    }
	public virtual void Setup()
	{
	}
    public virtual void Output() {
      foreach(ushort channel in ActivationPropagation.AllChannels) {
        gameObject.SendMessage("UseContinuous", new ActivationPropagation(gameObject, channel), SendMessageOptions.DontRequireReceiver);
      }
         if (!variable1 && ActivationMode >= 1) {
           variable1 = true;
           foreach(ushort channel in ActivationPropagation.AllChannels) {
             gameObject.SendMessage("Use", new ActivationPropagation(gameObject, channel), SendMessageOptions.DontRequireReceiver);
           }
         }
	  //this.light.SetActive(true);
    }
    public virtual bool Checks() {
      return true;
    }
    public virtual void Updater() {
      if (Checks()) {
		  this.light.SetActive(true);
		  framebuff = 0;
        Output();
      }
      activeslots.Clear();
    }
	public virtual void FixedUpdate() {
		Updater();
		// I must align the light shutoff logic between the nodes and the gate.
		//Debug.Log(framebuff+":"+framebufflimit);
		if(framebuff == framebufflimit)
		{
			//Debug.Log("reset");
			if(variable1 && ActivationMode == 2)
			{
			foreach(ushort channel in ActivationPropagation.AllChannels) {
			gameObject.SendMessage("Use", new ActivationPropagation(gameObject, channel), SendMessageOptions.DontRequireReceiver);
			}
			//variable1 = false;
			}
			framebuff = 0;
			variable1 = false;
		this.light.SetActive(false);
		}
		else
		{
			framebuff++;
		}
	}
	protected SettingsMenu SettingsInstance = null;
	public void LoadMenu()
	{
		Dictionary < int, string > namekeys = new Dictionary < int, string > () {
         {
           0,
           "None"
         }, {
           1,
           "Single Trigger"
         }, {
           2,
           "Double Trigger"
         }
       };
	    if(SettingsInstance == null)
		{
		   SettingsInstance = new SettingsMenu();
		}
		SettingsInstance.Open(new DialogButton[]{
			 new DialogButton("Additional Triggers"+"\n<color=green><size=26>"+namekeys[ActivationMode]+"</size></color>", true, new UnityAction[1] {
             (UnityAction)(() => {
               int proccesing = ActivationMode;proccesing += 1;if(proccesing > 2){proccesing = 0;}
				ActivationMode = proccesing;LoadMenu();
             })
           })
	   });
	}
    public virtual void NodeActivation(ActivationPropagation activation, int slot,bool Continuous = true) {
		if(!Continuous && !AllowNonContinuous)
		{return;}
		//framebuff = 0;
      activeslots.Add(slot);
    }
	[SkipSerialisation]
	protected bool variable1 = false;
	[SkipSerialisation]
	protected int framebufflimit = 10;
	[SkipSerialisation]
	public bool AllowNonContinuous = false;
	[SkipSerialisation]
	public GameObject light_sprite;
	[SkipSerialisation]
	public GameObject light;
	public int ActivationMode = 0;
	[SkipSerialisation]
	public int framebuff = 0;
	[SkipSerialisation]
    public List < int > activeslots = new List < int > ();
  }
  public class AndGate : LogicGateBase {
	  public override bool Checks()
	  {
		  if(activeslots.Contains(1) && activeslots.Contains(2))
		  {
			  return true;
		  }
		  else
		  {
			  return false;
		  }
	  }
  }
  public class NotGate : LogicGateBase {
	  public override void Setup()
	  {
		  this.framebufflimit = 50;
	  }
	  public override bool Checks()
	  {
		  if(!activeslots.Any())
		  {
			  this.light.SetActive(true);
			  return true;
		  }
		  else
		  {
			  this.light.SetActive(false); //unsure
			  return false;
		  }
	  }
  }
  public class OrGate : LogicGateBase {
	  public override bool Checks()
	  {
		  if(activeslots.Any())
		  {
			  return true;
		  }
		  else
		  {
			  return false;
		  }
	  }
  }
  public class XorGate : LogicGateBase {
	  public override bool Checks()
	  {
		  if(activeslots.Count == 1)
		  {
			  return true;
		  }
		  else
		  {
			  return false;
		  }
	  }
  }
  public class CounterGate : LogicGateBase {
	  public override void Start()
	  {
		  light = gameObject.transform.Find("glow").gameObject;
		  TextObject = gameObject.transform.Find("text").gameObject;
		  Text = TextObject.GetComponent<TextMeshPro>();
		  this.AllowNonContinuous = true;
		  Text.enabled = true;
		  Text.autoSizeTextContainer = true;
		  Text.enableAutoSizing = true;
		  TextObject.transform.localPosition = new Vector3(-0.07f,0.05f);
		  Text.fontSizeMin = 0;
		  Text.alignment = TextAlignmentOptions.Center;
		  Text.fontSizeMax = 1;
		  Text.text = currentvalue.ToString();
		  PhysicalBehaviour pb = gameObject.GetComponent<PhysicalBehaviour>();
		pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("dasd", "Set Desired value", "Sets desired value.", () => {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Enter the range\n<color=green><size=26>Default: 5,Currently:"+desiredvalue+"</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
                  (UnityAction)(() => {
                    float setrange;
                    if (float.TryParse(dialog.EnteredText, out setrange)) {
                        if(setrange > 0)
                        {
                            desiredvalue = (int)setrange;
                        }
                        else
                        {
                            ModAPI.Notify("<color=red>Error: Desired value must be above 0.</color>");
                        }
                    }
                  })
                }),
                  new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));
			pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("settingsbutton","Other settings", "Please dont use with multiple parts...", () => {
         LoadMenu();
		}
		 )
		 );
	  }
	  void Sync()
	  {
		  Text.text = currentvalue.ToString();
	  }
	  public override void Updater()
	  {
	  if (Checks()) {
		  this.light.SetActive(true);
        Output();
      }
      activeslots.Clear();
	  }
	  public override bool Checks()
	  {
		  if(activeslots.Contains(2))
		  {
			  //Debug.Log("reset");
			  currentvalue = 0;
			  Sync();
			  return false;
		  }
		  if(currentvalue==desiredvalue)
		  {
			  //Debug.Log("desired");
			  return true;
		  }
		  else
		  {
			  return false;
		  }
	  }
	  public override void NodeActivation(ActivationPropagation activation, int slot,bool Continuous = true) {
		  if(Continuous){return;}
		this.light.SetActive(true);
		if(slot == 1)
		{
		currentvalue = Mathf.Clamp(currentvalue+1,0,desiredvalue);
		Sync();
		}
      activeslots.Add(slot);
	  }
	  //public override void FixedUpdate() {} // Not Used actually used now.
	  [SkipSerialisation]
	  public GameObject TextObject;
	  [SkipSerialisation]
	  public TextMeshPro Text;
	  public int desiredvalue = 5;
	  public int currentvalue = 0;
  }
}